package com.railway.web.controller.system;

import com.railway.common.annotation.Log;
import com.railway.common.constant.UserConstants;
import com.railway.common.core.controller.BaseController;
import com.railway.common.core.domain.AjaxResult;
import com.railway.common.core.domain.entity.SysMenu;
import com.railway.common.enums.BusinessType;
import com.railway.common.utils.StringUtils;
import com.railway.common.utils.TreeSelectUtil;
import com.railway.system.service.ISysMenuService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.List;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 菜单信息
 *
 * @author railway
 */
@Api(tags = "系统管理 - 菜单")
@RestController
@RequestMapping("/system/menu")
public class SysMenuController extends BaseController {

  private final ISysMenuService menuService;

  public SysMenuController(ISysMenuService menuService) {
    this.menuService = menuService;
  }

  /**
   * 获取菜单列表
   */
  @ApiOperation(value = "菜单列表", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:menu:list')")
  @GetMapping("/list")
  public AjaxResult list(SysMenu menu) {
    List<SysMenu> menus = menuService.selectMenuList(menu, getUserId());
    return AjaxResult.success(menus);
  }

  /**
   * 根据菜单编号获取详细信息
   */
  @ApiOperation(value = "根据菜单编号获取详细信息", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:menu:query')")
  @GetMapping(value = "/{menuId}")
  public AjaxResult getInfo(@PathVariable Long menuId) {
    return AjaxResult.success(menuService.selectMenuById(menuId));
  }

  /**
   * 获取菜单下拉树列表
   */
  @ApiOperation(value = "获取菜单下拉树列表")
  @GetMapping("/tree")
  public AjaxResult tree(SysMenu menu) {
    List<SysMenu> menus = menuService.selectMenuList(menu, getUserId());
    List<SysMenu> menuTree = menuService.buildMenuTree(menus);
    TreeSelectUtil.setMenuTree(menuTree);
    return AjaxResult.success(menuTree);
  }

  /**
   * 获取菜单下拉树列表
   */
  @ApiOperation(value = "获取菜单下拉树选择列表", response = AjaxResult.class)
  @GetMapping("/treeSelect")
  public AjaxResult treeSelect(SysMenu menu) {
    List<SysMenu> menus = menuService.selectMenuList(menu, getUserId());
    return AjaxResult.success(menuService.buildMenuTreeSelect(menus));
  }

  /**
   * 加载对应角色菜单列表树
   */
  @ApiOperation(value = "加载对应角色菜单选择列表树", response = AjaxResult.class)
  @GetMapping(value = "/roleMenuTreeSelect/{roleId}")
  public AjaxResult roleMenuTreeSelect(@PathVariable("roleId") Long roleId) {
    List<SysMenu> menus = menuService.selectMenuList(getUserId());
    AjaxResult ajax = AjaxResult.success();
    ajax.put("checkedKeys", menuService.selectMenuListByRoleId(roleId));
    ajax.put("menus", menuService.buildMenuTreeSelect(menus));
    return ajax;
  }

  /**
   * 新增菜单
   */
  @ApiOperation(value = "新增菜单", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:menu:add')")
  @Log(title = "菜单管理", businessType = BusinessType.INSERT)
  @PostMapping
  public AjaxResult add(@Validated @RequestBody SysMenu menu) {
    if (UserConstants.NOT_UNIQUE.equals(menuService.checkMenuNameUnique(menu))) {
      return AjaxResult.error("新增菜单'" + menu.getMenuName() + "'失败，菜单名称已存在");
    } else if (UserConstants.YES_FRAME.equals(menu.getIsFrame()) && !StringUtils.ishttp(
        menu.getPath())) {
      return AjaxResult.error("新增菜单'" + menu.getMenuName() + "'失败，地址必须以http(s)://开头");
    }
    menu.setCreateBy(getUsername());
    return toAjax(menuService.insertMenu(menu));
  }

  /**
   * 修改菜单
   */
  @ApiOperation(value = "修改菜单", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:menu:edit')")
  @Log(title = "菜单管理", businessType = BusinessType.UPDATE)
  @PutMapping
  public AjaxResult edit(@Validated @RequestBody SysMenu menu) {
    if (UserConstants.NOT_UNIQUE.equals(menuService.checkMenuNameUnique(menu))) {
      return AjaxResult.error("修改菜单'" + menu.getMenuName() + "'失败，菜单名称已存在");
    } else if (UserConstants.YES_FRAME.equals(menu.getIsFrame()) && !StringUtils.ishttp(
        menu.getPath())) {
      return AjaxResult.error("修改菜单'" + menu.getMenuName() + "'失败，地址必须以http(s)://开头");
    } else if (menu.getMenuId().equals(menu.getParentId())) {
      return AjaxResult.error("修改菜单'" + menu.getMenuName() + "'失败，上级菜单不能选择自己");
    }
    menu.setUpdateBy(getUsername());
    return toAjax(menuService.updateMenu(menu));
  }

  /**
   * 删除菜单
   */
  @ApiOperation(value = "删除菜单", response = AjaxResult.class)
  @PreAuthorize("@ss.hasPermi('system:menu:remove')")
  @Log(title = "菜单管理", businessType = BusinessType.DELETE)
  @DeleteMapping("/{menuId}")
  public AjaxResult remove(@PathVariable("menuId") Long menuId) {
    if (menuService.hasChildByMenuId(menuId)) {
      return AjaxResult.error("存在子菜单,不允许删除");
    }
    if (menuService.checkMenuExistRole(menuId)) {
      return AjaxResult.error("菜单已分配,不允许删除");
    }
    return toAjax(menuService.deleteMenuById(menuId));
  }
}